Unit Unit1;

{$MODE objfpc}{$H+}

Interface

Uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

Type

  { TForm1 }

  TForm1 = Class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure Button3Click(Sender: TObject);
    Procedure Button4Click(Sender: TObject);
    Procedure Button5Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  End;

  { TTest }

  generic TTest < T > = Class
  private
    FA: Array Of T;
  public
    Constructor Create;
    Destructor Destroy; override;
    Procedure Add(V: T);
    Function Get(): T;
    Function Empty: Boolean;
  End;

Var
  Form1: TForm1;

Implementation

{$R *.lfm}

{ TForm1 }

Procedure TForm1.Button1Click(Sender: TObject);
Type
  tt = specialize TTest < integer > ;
Var
  t: tt;
  i: Integer;
Begin
  t := tt.create;
  For i := 0 To 10 Do Begin
    t.add(i);
  End;
  For i := 0 To 10 Do Begin
    If t.get <> i Then Begin
      Raise exception.create('Fehler');
    End;
  End;
End;

Procedure TForm1.Button2Click(Sender: TObject);
Type
  tt = specialize TTest < String > ;
Var
  t: tt;
  i: Integer;
Begin
  t := tt.create;
  For i := 0 To 10 Do Begin
    t.add(inttostr(i));
  End;
  For i := 0 To 10 Do Begin
    If strtoint(t.get) <> i Then Begin
      Raise exception.create('Fehler');
    End;
  End;
End;

Procedure TForm1.Button3Click(Sender: TObject);
Type
  trec = Record
    a: Array Of Integer;
    b: integer;
  End;

  tt = specialize TTest < trec > ;
Var
  tr: trec;
  t: tt;
  i: Integer;
Begin
  t := tt.create;
  For i := 0 To 10 Do Begin
    setlength(tr.a, 2);
    tr.a[0] := i;
    tr.a[1] := 42 - i;
    tr.b := i + 100;
    t.add(tr);
  End;
  For i := 0 To 10 Do Begin
    tr := t.get;
    If (high(tr.a) <> 1) Or
      (tr.a[0] <> i) Or
      (tr.a[1] <> 42 - i) Or
      (tr.b <> i + 100) Then Begin
      Raise exception.create('Fehler');
    End;
  End;
End;

Procedure TForm1.Button4Click(Sender: TObject);
Type
  trec = Record
    a: Integer;
    b: integer;
  End;

  tt = specialize TTest < trec > ;
Var
  tr: trec;
  t: tt;
  i: Integer;
Begin
  t := tt.create;
  For i := 0 To 10 Do Begin
    tr.a := i;
    tr.b := i + 100;
    t.add(tr);
  End;
  For i := 0 To 10 Do Begin
    tr := t.get;
    If (tr.a <> i) Or
      (tr.b <> i + 100) Then Begin
      Raise exception.create('Fehler');
    End;
  End;
End;

Procedure TForm1.Button5Click(Sender: TObject);
Type
  trec = Record
    a: Array Of Integer;
    b: integer;
  End;
  Prec = ^trec;

  tt = specialize TTest < Prec > ;
Var
  tr: Prec;
  t: tt;
  i: Integer;
Begin
  t := tt.create;
  For i := 0 To 10 Do Begin
    new(tr);
    setlength(tr^.a, 2);
    tr^.a[0] := i;
    tr^.a[1] := 42 - i;
    tr^.b := i + 100;
    t.add(tr);
  End;
  For i := 0 To 10 Do Begin
    tr := t.get;
    If (high(tr^.a) <> 1) Or
      (tr^.a[0] <> i) Or
      (tr^.a[1] <> 42 - i) Or
      (tr^.b <> i + 100) Then Begin
      Raise exception.create('Fehler');
    End;
    dispose(tr);
  End;

End;

{ TTest }

Constructor TTest.Create;
Begin
  fa := Nil;
End;

Destructor TTest.Destroy;
Begin
  setlength(fa, 0);
End;

Procedure TTest.Add(V: T);
Var
  i: integer;
Begin
  setlength(fa, length(fa) + 1);
  { // Funktioniert nur mit Integern
  move(fa[0], fa[1], high(fa) * sizeof(t));
  // }
  //{ // Funktioniert mit allen 3en
  For i := high(fa) Downto 1 Do Begin
    fa[i] := fa[i - 1];
  End;
  // }
  fa[0] := v;
End;

Function TTest.Get: T;
Begin
  result := fa[high(fa)];
  setlength(fa, high(fa));
End;

Function TTest.Empty: Boolean;
Begin
  result := assigned(fa);
End;

End.

